//+------------------------------------------------------------------+
//|                                              SHMEN-DASHBOARD.mq4 |
//|                                                            Bendo |
//|                                               http://www.done.ca |
// Always appreciate donations that are paypalled to: bendo@shaw.ca

//+------------------------------------------------------------------+
#property copyright "Bendo"
#property link      "http://www.done.ca"
// Always appreciate donations that are paypalled to: bendo@shaw.ca

#include <stdlib.mqh>
#include <stderror.mqh>


//---- input parameters

extern int       Targets=2;
extern int       Max_Slip=1000;
extern int       Units_Per_Trade=1;


extern double    Standard_Lot_Size;

extern bool      Market_Orders=True;
extern bool      Resting_Orders=True;
extern bool      Action_Line=True;
extern int       Lot_Precision=2; // 1 for minilots, 2 for microlots, 3 for nano, 0 for standard

extern int      Risk_Management=0; // 0 = Standard LotSize is Actual Lotsize....1 = Standard LotSize is a portion of equity....2 = Complex LotSizes

extern int   Default_Stop;
extern int   Default_Take1;
extern int   Default_Take2;
extern int   Default_Take3;
extern int   Default_Take4;

//extern color   Arrow_Color;
extern color Text_Color=White;

extern string Font = "Times New Roman"; 

extern int Font_Size=10;
extern int Icon_Size=1;

double   Lot_Size;
double   Stop_Loss;
double   Entry;
double   TStop;
double   TTake1;
double   TTake2;
double   TTake3;
double   TTake4;
double   Target1;
double   Target2;
double   Target3;
double   Target4;
double   Resting_Target; 
double   Risk_Reward;

double   Bottom_Adjust = 10;

int   MagicNumber = 77077;
int   Select = -1;
double   Pips_Deposit;
bool  Action_Taken;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

Pips_Deposit = MarketInfo(Symbol(), MODE_TICKVALUE);
//Alert("Pips Value"+Pips_Deposit);

Risk_Management= GlobalVariableGet("G_Risk_Management");
Standard_Lot_Size= GlobalVariableGet("G_Lot_Size");

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   GlobalVariableSet("G_Lot_Size", Standard_Lot_Size);
   GlobalVariableSet("G_Risk_Management", Risk_Management);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   while (true)
   {
      RefreshRates();
      Check_For_Inputs();
      Update_Board();
      Recalculate_Risk();
      WindowRedraw();
      Sleep(500);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void Update_Board()
{ 
   double Top = WindowPriceMax();
   double Bottom = WindowPriceMin();
   double Price_Unit = (Top-Bottom)/30;
   datetime Time_Unit = Period()*60;
   
   Bottom = Bottom + (Bottom_Adjust*Price_Unit);
   
  
   if (Action_Line) 
   {
      if (ObjectFind("Action_Line") == -1)
      {
         ObjectCreate ("Action_Line", OBJ_VLINE, 0, Time[0]+Time_Unit, Bottom + Price_Unit);
         ObjectSet ("Action_Line", OBJPROP_COLOR, Text_Color);
      }
      else
      {
         ObjectSet ("Action_Line", OBJPROP_TIME1, Time[0]+Time_Unit);          
      }
   }
   
   if (ObjectFind("Select") == -1)
   {
      ObjectCreate ("Select", OBJ_ARROW, 0, Time[0] + Time_Unit*8, Bottom + Price_Unit*2.5);
      ObjectSet ("Select", OBJPROP_ARROWCODE, 3);
      ObjectSet ("Select", OBJPROP_COLOR, Blue);
   }
   else
   {
       ObjectSet ("Select", OBJPROP_TIME1, Time[0] + Time_Unit*7);
       ObjectSet ("Select", OBJPROP_PRICE1, Bottom + Price_Unit*2.5);
           
   }
   
   if (ObjectFind("Safety") == -1)
   {
      ObjectCreate ("Safety", OBJ_ARROW, 0, Time[0] + Time_Unit*6, Bottom + Price_Unit*3);
      ObjectSet ("Safety", OBJPROP_ARROWCODE, SYMBOL_THUMBSUP);
   }
   else
   {
       ObjectSet ("Safety", OBJPROP_TIME1, Time[0] + Time_Unit*6);
       ObjectSet ("Safety", OBJPROP_PRICE1, Bottom + Price_Unit*3);
       if (!Action_Taken) ObjectSet ("Safety", OBJPROP_COLOR, Green); else ObjectSet ("Safety", OBJPROP_COLOR, Red);
            
   }
   
   if (ObjectFind("Stop_Loss_Icon") == -1)
   {
      ObjectCreate ("Stop_Loss_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*2, Bottom + Price_Unit*5);
      ObjectSetText ("Stop_Loss_Icon", "---", Font_Size, Font, Red);
   }
   else
   {
       ObjectSet ("Stop_Loss_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*2);
       ObjectSet ("Stop_Loss_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }

   if (ObjectFind("Entry_Icon") == -1)
   {
      ObjectCreate ("Entry_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*5);
      ObjectSetText ("Entry_Icon", "---", Font_Size, Font, Blue);
   }
   else
   {
       ObjectSet ("Entry_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*4);
       ObjectSet ("Entry_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }

   if (ObjectFind("Target1_Icon") == -1)
   {
      ObjectCreate ("Target1_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*6, Bottom + Price_Unit*5);
      ObjectSetText ("Target1_Icon", "---", Font_Size, Font, Green);
   }
   else
   {
       ObjectSet ("Target1_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*6);
       ObjectSet ("Target1_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   
   if (ObjectFind("Target2_Icon") == -1)
   {
      ObjectCreate ("Target2_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*8, Bottom + Price_Unit*5);
      ObjectSetText ("Target2_Icon", "---", Font_Size, Font, Green);
   }
   else
   {
       ObjectSet ("Target2_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*8);
       ObjectSet ("Target2_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   
   
   if (ObjectFind("Target3_Icon") == -1)
   {
      ObjectCreate ("Target3_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*10, Bottom + Price_Unit*5);
      ObjectSetText ("Target3_Icon", "---", Font_Size, Font, Green);
   }
   else
   {
       ObjectSet ("Target3_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*10);
       ObjectSet ("Target3_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   
   
   if (ObjectFind("Target4_Icon") == -1)
   {
      ObjectCreate ("Target4_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*12, Bottom + Price_Unit*5);
      ObjectSetText ("Target4_Icon", "---", Font_Size, Font, Green);
   }
   else
   {
       ObjectSet ("Target4_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*12);
       ObjectSet ("Target4_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }

   if (ObjectFind("Delete_Order") == -1)
   {
      
      ObjectCreate ("Delete_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*6 , Bottom + Price_Unit*4);
      ObjectSet ("Delete_Order", OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
      ObjectSet ("Delete_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Delete_Order", OBJPROP_TIME1, Time[0] + Time_Unit*6);
      ObjectSet ("Delete_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }

   if (ObjectFind("Update_Order") == -1)
   {
      
      ObjectCreate ("Update_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*8 , Bottom + Price_Unit*4);
      ObjectSet ("Update_Order", OBJPROP_ARROWCODE, SYMBOL_CHECKSIGN);
      ObjectSet ("Update_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Update_Order", OBJPROP_TIME1, Time[0] + Time_Unit*8);
      ObjectSet ("Update_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }

   
   if (ObjectFind("Market_Buy_Order") == -1)
   {
      
      ObjectCreate ("Market_Buy_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*2 , Bottom + Price_Unit*4);
      ObjectSet ("Market_Buy_Order", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet ("Market_Buy_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Market_Buy_Order", OBJPROP_TIME1, Time[0] + Time_Unit*2);
      ObjectSet ("Market_Buy_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }
   

   if (ObjectFind("Market_Sell_Order") == -1)
   {
      
      ObjectCreate ("Market_Sell_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*4 , Bottom + Price_Unit*4);
      ObjectSet ("Market_Sell_Order", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet ("Market_Sell_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Market_Sell_Order", OBJPROP_TIME1, Time[0] + Time_Unit*4);
      ObjectSet ("Market_Sell_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }
   

   
   
   if (Stop_Loss != 0)
   {
      if (ObjectFind("Stop_Loss") == -1)
      {
         ObjectCreate ("Stop_Loss", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Stop_Loss);
         ObjectSet ("Stop_Loss", OBJPROP_COLOR, Red);      
      }
   }
   
   if (Entry != 0)
   {
      if (ObjectFind("Entry") == -1)
      {
         ObjectCreate ("Entry", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Entry);      
         ObjectSet ("Entry", OBJPROP_COLOR, Blue);      
      }
   }

   if (Target1 != 0)
   {
      if (ObjectFind("Target1") == -1)
      {
         ObjectCreate ("Target1", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Target1);      
         ObjectSet ("Target1", OBJPROP_COLOR, Green);      
      }
   }

   if (Target2 != 0)
   {
      if (ObjectFind("Target2") == -1)
      {
         ObjectCreate ("Target2", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Target2);      
         ObjectSet ("Target2", OBJPROP_COLOR, Green);      
      }
   }
   if (Target3 != 0)
   {
      if (ObjectFind("Target3") == -1)
      {
         ObjectCreate ("Target3", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Target3);      
         ObjectSet ("Target3", OBJPROP_COLOR, Green);      
      }
   }
   if (Target4 != 0)
   {
      if (ObjectFind("Target4") == -1)
      {
         ObjectCreate ("Target4", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Target4);      
         ObjectSet ("Target4", OBJPROP_COLOR, Green);      
      }
   }
   
   if (ObjectFind("Risk_Reward") == -1)
   {
      ObjectCreate ("Risk_Reward", OBJ_TEXT, 0, Time[0] + Time_Unit*6 , Bottom + Price_Unit);
      ObjectSet ("Risk_Reward", OBJPROP_COLOR, Text_Color);                     
   }
   else
   {
      ObjectSet ("Risk_Reward", OBJPROP_TIME1, Time[0] + Time_Unit*6);            
      ObjectSet ("Risk_Reward", OBJPROP_PRICE1, Bottom + Price_Unit);            
      ObjectSetText ("Risk_Reward", "R:R: "+ DoubleToStr( Risk_Reward, 2) +" : 1", Font_Size, Font, Text_Color);
   }
   
   if (ObjectFind("Selected_Trade") == -1)
   {
      ObjectCreate ("Selected_Trade", OBJ_TEXT, 0, Time[0] + Time_Unit*6 , Bottom);
      ObjectSet ("Selected_Trade", OBJPROP_COLOR, Text_Color);                     
   }
   else
   {
      string SelectS = "" + Select;
      if (Select == -1) SelectS = "NEW";
      ObjectSet ("Selected_Trade", OBJPROP_TIME1, Time[0] + Time_Unit*6);            
      ObjectSet ("Selected_Trade", OBJPROP_PRICE1, Bottom);            
      ObjectSetText ("Selected_Trade", "Order: "+ SelectS, Font_Size, Font, Text_Color);
   }


   
   switch (Risk_Management)
   {
      case 0:
      {
         if (ObjectFind("Lot_Size") == -1)
         {
            ObjectCreate ("Lot_Size", OBJ_TEXT, 0, Time[0] + Time_Unit*6 , Bottom + Price_Unit*2);
            ObjectSet ("Lot_Size", OBJPROP_COLOR, Text_Color);
                       
         }
         else
         {
            ObjectSet ("Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*6);            
            ObjectSet ("Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*2);            
            ObjectSetText ("Lot_Size", "Lot Size: "+ DoubleToStr( Lot_Size, Lot_Precision) , Font_Size, Font, Text_Color);
         }
         
         if (ObjectFind("Inc_Lot_Size") == -1)
         {
            ObjectCreate("Inc_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*2, Bottom + Price_Unit*3);
            ObjectSet ("Inc_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
            ObjectSet ("Inc_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Inc_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*2);            
            ObjectSet ("Inc_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         if (ObjectFind("Dec_Lot_Size") == -1)
         {
            ObjectCreate("Dec_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*3);
            ObjectSet ("Dec_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
            ObjectSet ("Dec_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Dec_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*4);            
            ObjectSet ("Dec_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         break;
      }
      
      
      case 1:
      {
         if (ObjectFind("Lot_Size") == -1)
         {
            ObjectCreate ("Lot_Size", OBJ_TEXT, 0, Time[0] + Time_Unit*8 , Bottom + Price_Unit*2);
            ObjectSet ("Lot_Size", OBJPROP_COLOR, Text_Color);                     
         }
         else
         {
            ObjectSet ("Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*8);            
            ObjectSet ("Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*2);            
            ObjectSetText ("Lot_Size", "Lots: "+ DoubleToStr( Lot_Size, Lot_Precision) +"  "+" E: "+DoubleToStr( Standard_Lot_Size, 1)+"%" , Font_Size, Font, Text_Color);
         }
         
         
         
         if (ObjectFind("Inc_Lot_Size") == -1) 
         {
            ObjectCreate("Inc_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*2, Bottom + Price_Unit*3);
            ObjectSet ("Inc_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
            ObjectSet ("Inc_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Inc_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*2);            
            ObjectSet ("Inc_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         
         
         if (ObjectFind("Dec_Lot_Size") == -1)
         {
            ObjectCreate("Dec_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*3);
            ObjectSet ("Dec_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
            ObjectSet ("Dec_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Dec_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*4);            
            ObjectSet ("Dec_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         break;

      }
   }
}     
      
void Check_For_Inputs()
{
   if (ObjectFind("Market_Buy_Order") != -1)

   {
      if (ObjectGet("Market_Buy_Order", OBJPROP_TIME1) <= Time [0] )
      {
         //Imediately Place Order
         if (!Action_Taken) 
         {
            Buy_At_Market();
            Action_Taken = true;
         }
      }
   }
   
   if (ObjectFind("Market_Sell_Order") != -1)
   {
      if (ObjectGet("Market_Sell_Order", OBJPROP_TIME1) <= Time [0] )
      {
         //Imediately Place Order
         if (!Action_Taken) 
         {
            Sell_At_Market();
            Action_Taken = true;
         }
      }
   }
   
   
   if (ObjectFind("Safety") != -1)

   {
      if (ObjectGet("Safety", OBJPROP_TIME1) <= Time [0] )
      {
         //Reload Safety
         Action_Taken = false;


      }
   }


   if (ObjectFind("Inc_Lot_Size") != -1)

   {
      if (ObjectGet("Inc_Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         if (Risk_Management == 0)
            Standard_Lot_Size = Standard_Lot_Size + 1.0/MathPow(10,Lot_Precision);
         else
            Standard_Lot_Size = Standard_Lot_Size + 0.5;


      }
   }

   if (ObjectFind("Dec_Lot_Size") != -1)

   {
      if (ObjectGet("Dec_Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         //Reload Safety
         if (Risk_Management == 0)
            Standard_Lot_Size = Standard_Lot_Size - 1.0/MathPow(10,Lot_Precision);
         else
            Standard_Lot_Size = Standard_Lot_Size - 0.5;
   
      }
   }
   
   if (ObjectFind("Stop_Loss") != -1)
   {
      Stop_Loss = ObjectGet("Stop_Loss", OBJPROP_PRICE1);          
   }
   else
   {
      Stop_Loss = 0;
      
   }
   if (ObjectFind("Stop_Loss_Icon") != -1)

   {
      if (ObjectGet("Stop_Loss_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Stop_Loss = ObjectGet("Stop_Loss_Icon", OBJPROP_PRICE1);
         ObjectSet("Stop_Loss", OBJPROP_PRICE1, Stop_Loss);
         
      }
   }
   

   if (ObjectFind("Entry") != -1)
   {
      Entry = ObjectGet("Entry", OBJPROP_PRICE1);          
   }
   else
   {
      Entry = 0;
      
   }
   if (ObjectFind("Entry_Icon") != -1)

   {
      if (ObjectGet("Entry_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Entry = ObjectGet("Entry_Icon", OBJPROP_PRICE1);
         ObjectSet("Entry", OBJPROP_PRICE1, Entry);
         
      }
   }

   if (ObjectFind("Target1") != -1)
   {
      Target1 = ObjectGet("Target1", OBJPROP_PRICE1);          
   }
   else
   {
      Target1 = 0;
      
   }
   if (ObjectFind("Target1_Icon") != -1)

   {
      if (ObjectGet("Target1_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target1 = ObjectGet("Target1_Icon", OBJPROP_PRICE1);
         ObjectSet("Target1", OBJPROP_PRICE1, Target1);
         
      }
   }

   if (ObjectFind("Target2") != -1)
   {
      Target2 = ObjectGet("Target2", OBJPROP_PRICE1);          
   }
   else
   {
      Target2 = 0;
      
   }
   if (ObjectFind("Target2_Icon") != -1)

   {
      if (ObjectGet("Target2_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target2 = ObjectGet("Target2_Icon", OBJPROP_PRICE1);
         ObjectSet("Target2", OBJPROP_PRICE1, Target2);
         
      }
   }

   if (ObjectFind("Target3") != -1)
   {
      Target3 = ObjectGet("Target3", OBJPROP_PRICE1);          
   }
   else
   {
      Target3 = 0;
      
   }
   if (ObjectFind("Target3_Icon") != -1)

   {
      if (ObjectGet("Target3_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target3 = ObjectGet("Target3_Icon", OBJPROP_PRICE1);
         ObjectSet("Target3", OBJPROP_PRICE1, Target3);
         
      }
   }

   if (ObjectFind("Target4") != -1)
   {
      Target4 = ObjectGet("Target4", OBJPROP_PRICE1);          
   }
   else
   {
      Target4 = 0;
      
   }
   if (ObjectFind("Target4_Icon") != -1)

   {
      if (ObjectGet("Target4_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         
         Target4 = ObjectGet("Target4_Icon", OBJPROP_PRICE1);
         ObjectSet("Target4", OBJPROP_PRICE1, Target4);
         
      }
   }

   if (ObjectFind("Lot_Size") != -1)

   {
      if (ObjectGet("Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         
         Risk_Management++;
         if (Risk_Management > 1) Risk_Management = 0;
         Standard_Lot_Size = 0;
         
      }
   }

   if (ObjectFind("Delete_Order") != -1)
   {
      if (ObjectGet("Delete_Order", OBJPROP_TIME1) <= Time [0] )
      {
        if (Select > -1)
        {
         OrderSelect(Select,SELECT_BY_POS);
         if (OrderType()>1)
         {
            OrderDelete(OrderTicket());
            Alert("Closing Resting Order type:"+OrderType()+" Ticket:"+OrderTicket() + "Error:" + GetLastError());
         } 
         else 
         {
            if (OrderType() == OP_BUY) OrderClose(OrderTicket(),Lot_Size,NormalizeDouble(Bid,Digits),Max_Slip);
            else OrderClose(OrderTicket(),Lot_Size,NormalizeDouble(Ask,Digits),Max_Slip);
            Alert("Closing Open Order type:"+OrderType()+" Ticket:"+OrderTicket()+ "Error:" + GetLastError());

         }
         Select = -1;               
         ObjectDelete ("Target1");
         Target1 = 0;
         ObjectDelete ("Stop_Loss");
         Stop_Loss = 0;
         ObjectDelete ("Entry");
         Entry = 0;
        }
            
      }
   }

   if (ObjectFind("Update_Order") != -1)

   {
      if (ObjectGet("Update_Order", OBJPROP_TIME1) <= Time [0] )
      {
        OrderSelect(Select,SELECT_BY_POS);
        OrderModify(OrderTicket(),Entry,Stop_Loss,Target1,0);            
      }
   }


   if (ObjectFind("Select") != -1 && ObjectFind("Selected_Trade") != -1)
   {
      if (ObjectGet("Select", OBJPROP_TIME1) <= Time [0] || ObjectGet("Selected_Trade", OBJPROP_TIME1) <= Time [0] )
      {
         bool NoTradeFound = true;
         //Alert("deleting");
         ObjectDelete ("Target1");
         Target1 = 0;
         ObjectDelete ("Stop_Loss");
         Stop_Loss = 0;
         ObjectDelete ("Entry");
         Entry = 0;
         Risk_Management = 0;
         Standard_Lot_Size = 0;
         while (NoTradeFound)
         {
            Select ++;
    
            if (Select > OrdersTotal()) 
            {
               Select = -1;
               NoTradeFound = false;    
            }
            else
            {
               if (OrderSelect(Select, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() ) 
               {
                  //Alert("Found Active Order");
                  Stop_Loss = OrderStopLoss();
                  Target1 = OrderTakeProfit();
                  Entry = OrderOpenPrice(); 
                  Standard_Lot_Size = OrderLots();
                  NoTradeFound = false; 
               }
            }
         }
      }
   }

}

void Recalculate_Risk()
{
   if (Lot_Size < 0) Lot_Size =0;
   if (Standard_Lot_Size < 0) Standard_Lot_Size =0;
   if (Target1 !=0 && Stop_Loss !=0)
   {
      if (Entry != 0)
      {
         Risk_Reward = (Target1 - Entry) / (Entry - Stop_Loss) ;
      }
      else
      {
         Risk_Reward = (Target1 - Close[0]) / (Close[0] - Stop_Loss) ;
      }
      
   }
   else
   {
      Risk_Reward = 0;
   }   
   if (Risk_Management == 0)
   {
      Lot_Size = NormalizeDouble(Standard_Lot_Size,Lot_Precision);
   }   

   if (Risk_Management == 1)
   {  
      if (Stop_Loss != 0)
      {
         if (Entry != 0)
         {
            if (Stop_Loss > Entry)
            {
               if (Stop_Loss-Entry != 0)
               Lot_Size = NormalizeDouble(Standard_Lot_Size/((Stop_Loss-Entry)/Point/Pips_Deposit*10),2);     
            }
            else
            {
               if (Stop_Loss-Entry != 0)
               Lot_Size = NormalizeDouble(Standard_Lot_Size/((Entry-Stop_Loss)/Point/Pips_Deposit*10),2);     

            }
         }
         else
         {
            if (Stop_Loss > Ask)
            {
               
               Lot_Size = NormalizeDouble(Standard_Lot_Size/((Stop_Loss-Ask)/Point),2);  

            }
            if (Stop_Loss < Bid)
            {
               Lot_Size = NormalizeDouble(Standard_Lot_Size/((Bid-Stop_Loss)/Point),2);  
            
            }
         }
         
       
      }
      else
      {
         Lot_Size = 0;
      }
   }   

}

void Buy_At_Market()
{
   if (Stop_Loss != 0)
   {
      TStop = NormalizeDouble(Stop_Loss,Digits);
   } 
   else
   {
      if (Default_Stop != 0) TStop = Ask - Default_Stop * Point; else TStop = 0;
   }
      
   if (Target1 != 0)
   {
      TTake1 = NormalizeDouble(Target1,Digits);
   } 
   else
   {
      if (Default_Take1 != 0) TTake1 = Ask + Default_Take1 * Point; else TTake1 = 0;
   }

   if (Target2 != 0)
   {
      TTake2 = Target2;
   } 
   else
   {
      if (Default_Take2 != 0) TTake2 = Ask + Default_Take2 * Point; else TTake2 = 0;
   }

   if (Target3 != 0)
   {
      TTake3 = Target3;
   } 
   else
   {
      if (Default_Take3 != 0) TTake3 = Ask + Default_Take3 * Point; else TTake3 = 0;
   }

   if (Target4 != 0)
   {
      TTake4 = Target4;
   } 
   else
   {
      if (Default_Take4 != 0) TTake4 = Ask + Default_Take4 * Point; else TTake4 = 0;
   }
   if (Entry == 0)   
   {
      OrderSend(Symbol(),OP_BUY,Lot_Size,NormalizeDouble(Ask,Digits),Max_Slip,TStop,TTake1,TimeCurrent()+"U1",MagicNumber,0);
      Alert ("Buy_Market"+Symbol()+" "+OP_BUY+" "+Lot_Size+" "+Ask+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+"U1 "+MagicNumber + " ERROR:" +GetLastError()   );
   }
   else
   {
      Alert ("Buy_Resting"+Symbol()+" EO "+Lot_Size+" "+Entry+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+"U1 "+MagicNumber);
      Entry = NormalizeDouble(Entry,Digits);
      if (Entry < Ask) OrderSend(Symbol(),OP_BUYLIMIT,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+"U1",MagicNumber,0); 
      else OrderSend(Symbol(),OP_BUYSTOP,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+"U1",MagicNumber,0);
   }
   //Entry = NormalizeDouble(Entry,);
   //if (Units_Per_Trade > 1) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake2,TimeCurrent()+"U2",MagicNumber,0);
   //if (Units_Per_Trade > 2) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake3,TimeCurrent()+"U3",MagicNumber,0);
   //if (Units_Per_Trade > 3) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake4,TimeCurrent()+"U4",MagicNumber,0);
   Select = -1;               
   ObjectDelete ("Target1");
   Target1 = 0;
   ObjectDelete ("Stop_Loss");
   Stop_Loss = 0;
   ObjectDelete ("Entry");
   Entry = 0;
}


void Sell_At_Market()
{
   if (Stop_Loss != 0)
   {
      TStop = NormalizeDouble(Stop_Loss,Digits);
   } 
   else
   {
      if (Default_Stop != 0) TStop = Bid - Default_Stop * Point; else TStop = 0;
   }
      
   if (Target1 != 0)
   {
      TTake1 = NormalizeDouble(Target1,Digits);
   } 
   else
   {
      if (Default_Take1 != 0) TTake1 = Bid + Default_Take1 * Point; else TTake1 = 0;
   }

   if (Target2 != 0)
   {
      TTake2 = Target2;
   } 
   else
   {
      if (Default_Take2 != 0) TTake2 = Bid + Default_Take2 * Point; else TTake2 = 0;
   }

   if (Target3 != 0)
   {
      TTake3 = Target3;
   } 
   else
   {
      if (Default_Take3 != 0) TTake3 = Bid + Default_Take3 * Point; else TTake3 = 0;
   }

   if (Target4 != 0)
   {
      TTake4 = Target4;
   } 
   else
   {
      if (Default_Take4 != 0) TTake4 = Bid + Default_Take4 * Point; else TTake4 = 0;
   }
   if (Entry == 0)   
   {
      OrderSend(Symbol(),OP_SELL,Lot_Size,NormalizeDouble(Bid,Digits),Max_Slip,NormalizeDouble(TStop,Digits),NormalizeDouble(TTake1,Digits),TimeCurrent()+"U1",MagicNumber,0);
      Alert ("Sell_Market"+Symbol()+" "+OP_SELL+" "+Lot_Size+" "+Bid+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+"U1 "+MagicNumber + " Error:"+GetLastError());
   }
   else
   {
     Alert ("Sell_Resting"+Symbol()+" EO "+Lot_Size+" "+Bid+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+"U1 "+MagicNumber);
     Entry = NormalizeDouble(Entry,Digits);
     if (Entry < Bid) OrderSend(Symbol(),OP_SELLSTOP,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+"U1",MagicNumber,0); 
     else OrderSend(Symbol(),OP_SELLLIMIT,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+"U1",MagicNumber,0);
   }
   
   
   //Entry = NormalizeDouble(Entry,);
   //if (Units_Per_Trade > 1) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake2,TimeCurrent()+"U2",MagicNumber,0);
   //if (Units_Per_Trade > 2) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake3,TimeCurrent()+"U3",MagicNumber,0);
   //if (Units_Per_Trade > 3) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake4,TimeCurrent()+"U4",MagicNumber,0);
   Select = -1;               
   ObjectDelete ("Target1");
   Target1 = 0;
   ObjectDelete ("Stop_Loss");
   Stop_Loss = 0;
   ObjectDelete ("Entry");
   Entry = 0;

}       
        